package bookRecommend;
import java.util.Random;


/**
 * Main class for the book recommendation program.
 *
 */
public class BookRecommend {

	/**
	 * Main - receives the arguments from the user and verifies input validity.
	 * Usage: BookRecommend <books filename> <ratings filename> <member ID number>
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		/* Your Code Goes Here */
	}

	/**
	 * Returns the book that is recommended to the user m1 based on the similarity of his ratings to the ratings of other members.
	 * If no book recommendation can be found in the system (either the user has already rated all books, or nobody rated certain books)
	 * the method will return null.
	 * 
	 * @param members - array of all members
	 * @param books	- array of all the books
	 * @param m1 - the member for whom we need to find a recommendation
	 * @return the book that is recommended to the user m1 based on the similarity of his ratings to the ratings of other members.
	 */
	public static IBook getRecommendationByCollaborativeFiltering(IMember[] members, IBook[] books, IMember m1) {
		/* Your Code Goes Here */
	}

	/**
	 * Returns the book that is recommended to the user m1, which has the highest rating in the system and the user m1 hasn't rated yet.
	 * If no book recommendation can be found in the system (either the user has already rated all books, or nobody rated certain books)
	 * the method will return null.
	 * 
	 * @param books
	 * @param m1
	 * @return the book that is recommended to the user m1, which has the highest rating in the system and the user m1 hasn't rated yet.
	 */
	public static IBook getRecommendationByAverageRating(IMember[] members,IBook[] books, IMember m1) {
		/* Your Code Goes Here */
	}
	
	/**
	 * Returns a random book which the given user hasn't rated yet.
	 * 
	 * @pre !member.hasReadAllBooksInSystem()
	 * @param books
	 * @param member
	 * @return a random book which the given user hasn't rated yet.
	 */
	public static IBook getRandomUnratedBook(IBook[] books, IMember member){
		/* Your Code Goes Here */
	}
}
